unit uTestChars;

interface

uses
  TestFramework, SysUtils;

type
  TTestChars = class(TTestCase)
  published
    procedure Test_CharInSet_255;
    procedure Test_CharEquals_255;
    procedure Test_CharInSet_FF;
    procedure Test_CharEquals_FF;
    procedure Test_CharInSet_00FF;
    procedure Test_CharEquals_00FF;

    procedure Test_CharInSet_255_HIGHCHARUNICODE;
    procedure Test_CharEquals_255_HIGHCHARUNICODE;
    procedure Test_CharInSet_FF_HIGHCHARUNICODE;
    procedure Test_CharEquals_FF_HIGHCHARUNICODE;
    procedure Test_CharInSet_00FF_HIGHCHARUNICODE;
    procedure Test_CharEquals_00FF_HIGHCHARUNICODE;
  end;

implementation

{ TTestChars }

procedure TTestChars.Test_CharEquals_00FF;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(Ch = #$00FF);
end;

{$HIGHCHARUNICODE ON}
procedure TTestChars.Test_CharEquals_00FF_HIGHCHARUNICODE;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(Ch = #$00FF);
end;
{$HIGHCHARUNICODE OFF}

procedure TTestChars.Test_CharEquals_255;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(Ch = #255);
end;

{$HIGHCHARUNICODE ON}
procedure TTestChars.Test_CharEquals_255_HIGHCHARUNICODE;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(Ch = #255);
end;
{$HIGHCHARUNICODE OFF}

procedure TTestChars.Test_CharEquals_FF;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(Ch = #$FF);
end;

{$HIGHCHARUNICODE ON}
procedure TTestChars.Test_CharEquals_FF_HIGHCHARUNICODE;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(Ch = #$FF);
end;
{$HIGHCHARUNICODE OFF}

procedure TTestChars.Test_CharInSet_00FF;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(CharInSet(Ch, [#1..#$00FF]));
end;

{$HIGHCHARUNICODE ON}
procedure TTestChars.Test_CharInSet_00FF_HIGHCHARUNICODE;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(CharInSet(Ch, [#1..#$00FF]));
end;
{$HIGHCHARUNICODE OFF}

procedure TTestChars.Test_CharInSet_255;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(CharInSet(Ch, [#1..#255]));
end;

{$HIGHCHARUNICODE ON}
procedure TTestChars.Test_CharInSet_255_HIGHCHARUNICODE;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(CharInSet(Ch, [#1..#255]));
end;
{$HIGHCHARUNICODE OFF}

procedure TTestChars.Test_CharInSet_FF;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(CharInSet(Ch, [#1..#$FF]));
end;

{$HIGHCHARUNICODE ON}
procedure TTestChars.Test_CharInSet_FF_HIGHCHARUNICODE;
var
  Ch: Char;
begin
  Ch := Chr($FF);
  CheckTrue(CharInSet(Ch, [#1..#$FF]));
end;
{$HIGHCHARUNICODE OFF}

initialization
  RegisterTest(TTestChars.Suite);

end.
